# Compare solution from own method to exact solution

import math
from green import *
import matplotlib.pyplot as plt

# Config
cl_ext = 1
cl_int = 0
centres = [0., 2./5.] # Outer circle is first in list
rayons = [1., 2./5.]
if (len(centres) != len(rayons)):
    print "Verifier nombre de cercles"
for cen, ray in zip(centres[1:], rayons[1:]):
    if (abs(cen-centres[0])+ray > rayons[0]):
        print "Verifier que le premier cercle est exterieur aux autres"

Nlist = [2, 5, 10, 20]
nptslist = [2, 4, 8, 16, 32, 64]


def cl_dirichlet(t, j):
    if j==0:
        res = cl_ext
    else:
        res = cl_int
    return res

def potentiel_harmonique(z):
    A = -(cl_int - cl_ext)/math.log(2)
    B = abs((2*z - 1)/(z-2))
    return A * math.log(B) + cl_ext

# Grid
xmin = -1.
xmax = 1.
xstep = 0.01
xvals = np.arange(xmin, xmax, xstep)
xpos = [x+1j*y for x in xvals for y in xvals
        if point_interieur(x+1j*y, centres, rayons)]

for N in Nlist:
    for npts in nptslist:
        zres = []
        for point in xpos:
            # u_green
            test = eval_u(point, cl_dirichlet, centres, rayons, npts, N)
            # u_exact
            refe = potentiel_harmonique(point)
            
            tmp = abs(test-refe)
            zres.append(tmp)
            
        print N, npts, sum(zres)/len(zres)
