import math
from green import *


# Config
marge = 20.
perturbList = [1e-2, 5e-3, 1e-3, 5e-4, 1e-4] #[1e-3, 1e-4, 1e-5, 1e-6, 1e-8, 1e-10]
N=5
npts=16
centres = [0., 2./5.] # Le premier cercle est ext\'erieur
rayons = [100., 5.]
if (len(centres) != len(rayons)):
    print "Verifier nombre de cercles"
for cen, ray in zip(centres[1:], rayons[1:]):
    if (abs(cen-centres[0])+ray > rayons[0]):
        print "Verifier que le premier cercle est exterieur aux autres"

#perturbList = [e*rayons[1] for e in perturbList]
        
# Perturbation du domaine
centres_pert = list(centres)
rayons_pert = list(rayons)
i_pert = -1

# Grille de points
xmin = -rayons[0]
xmax = rayons[0]
xstep = rayons[0]/10.
xvals = np.arange(xmin, xmax, xstep)

for perturb in perturbList:
    
    rayons_pert[i_pert] = rayons[i_pert] + perturb
    '''
    centres_pert[i_pert] = centres[i_pert] + perturb
    '''
    cen = centres[i_pert]
    ray = rayons[i_pert]
    
    def delta_rho(t):
        
        return perturb
        '''
        nx = -math.cos(t)
        ny = -math.sin(t)
        px = perturb.real
        py = perturb.imag
        res = px*nx + py*ny
        return res
        '''
    
    xpos = [x+1j*y for x in xvals for y in xvals
            if point_interieur(x+1j*y, centres_pert, rayons, marge)]
    
    zres = []
    for eta in xpos:
        # G0(eta, .) sur le domaine d'origine
        centres_T, rayons_T = inversion_domaine(centres, rayons, eta)
        z_T = points_collocation(centres_T, rayons_T, npts)
        a,b,d,e = coeffs_harmonique(centres_T, N, z_T)
        
        g0_eta = fonction_green(centres, rayons, eta, centres_T, a,b,d,e)
        grad_g0_eta = gradient_green(centres, eta, centres_T, a,b,d)
        
        # G1(eta, .) sur le domaine perturbe
        centres_pert_T, rayons_pert_T = inversion_domaine(centres_pert, rayons_pert, eta)
        z_T = points_collocation(centres_pert_T, rayons_pert_T, npts)
        a,b,d,e = coeffs_harmonique(centres_pert_T, N, z_T)
        
        g1_eta = fonction_green(centres_pert, rayons_pert, eta, centres_pert_T, a,b,d,e)
        
        for zeta in xpos:
            # calcul directe de G0(eta, zeta) sur le domaine initial
            g0 = g0_eta(zeta)
            
            # calcul directe de G1(eta, zeta) sur le domaine perturbe
            g1 = g1_eta(zeta)
            
            # variation de Hadamard : delta_G 
            grad_g0_zeta = gradient_green(centres, zeta, centres_T, a,b,d)
            d1 = delta_green(cen, ray, delta_rho, grad_g0_eta, grad_g0_zeta)
            
            # variation reelle : delta G * = G* - G
            d2 = g1 - g0
            
            # calcul de epsilon
            tmp = abs(d2 - d1) / (abs(d2) + abs(d1))
            if not math.isnan(tmp): # g not defined on certain points. ignore.
                zres.append(tmp)
    
    print perturb, sum(zres)/len(zres)
    
